// -*- c++ -*-
// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!
#ifndef _GOOCANVASMM_TEXTMODEL_H
#define _GOOCANVASMM_TEXTMODEL_H


#include <glibmm/ustring.h>
#include <sigc++/sigc++.h>

/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvasmm/itemmodelsimple.h>
#include <gtkmm/enums.h> /* For AnchorType. */
#include <pangomm/rectangle.h>
#include <pangomm/layout.h> //For Pango::Alignment


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GooCanvasTextModel GooCanvasTextModel;
typedef struct _GooCanvasTextModelClass GooCanvasTextModelClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Goocanvas
{ class TextModel_Class; } // namespace Goocanvas
#endif //DOXYGEN_SHOULD_SKIP_THIS

namespace Goocanvas
{


class TextModel : public Goocanvas::ItemModelSimple
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TextModel CppObjectType;
  typedef TextModel_Class CppClassType;
  typedef GooCanvasTextModel BaseObjectType;
  typedef GooCanvasTextModelClass BaseClassType;

  // noncopyable
  TextModel(const TextModel&) = delete;
  TextModel& operator=(const TextModel&) = delete;

private:  friend class TextModel_Class;
  static CppClassType textmodel_class_;

protected:
  explicit TextModel(const Glib::ConstructParams& construct_params);
  explicit TextModel(GooCanvasTextModel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:

  TextModel(TextModel&& src) noexcept;
  TextModel& operator=(TextModel&& src) noexcept;

  virtual ~TextModel() noexcept;

  /** Get the GType for this class, for use with the underlying GObject type system.
   */
  static GType get_type()      G_GNUC_CONST;

#ifndef DOXYGEN_SHOULD_SKIP_THIS


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GooCanvasTextModel*       gobj()       { return reinterpret_cast<GooCanvasTextModel*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GooCanvasTextModel* gobj() const { return reinterpret_cast<GooCanvasTextModel*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GooCanvasTextModel* gobj_copy();

private:

protected:

  TextModel(const Glib::ustring& string = Glib::ustring(), double x = 0.0, double y = 0.0, double width = -1, AnchorType anchor = ANCHOR_NORTH_WEST);
  

public:

  
  static Glib::RefPtr<TextModel> create(const Glib::ustring& string =  Glib::ustring(), double x =  0.0, double y =  0.0, double width =  -1, AnchorType anchor =  ANCHOR_NORTH_WEST);


  /** How to align the text.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Pango::Alignment > property_alignment() ;

/** How to align the text.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Pango::Alignment > property_alignment() const;

  /** How to position the text relative to the given x and y coordinates.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< AnchorType > property_anchor() ;

/** How to position the text relative to the given x and y coordinates.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< AnchorType > property_anchor() const;

  //gtkmmproc error: font : property defs lookup failed.
  //gtkmmproc error: font-desc : property defs lookup failed. //TODO: Use pointer? */
  /** The text to display.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< Glib::ustring > property_text() ;

/** The text to display.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::ustring > property_text() const;

  /** Whether to parse PangoMarkup in the text, to support different styles.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< bool > property_use_markup() ;

/** Whether to parse PangoMarkup in the text, to support different styles.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< bool > property_use_markup() const;

  /** The width to use to layout the text, or -1 to let the text use as much horizontal space as needed.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_width() ;

/** The width to use to layout the text, or -1 to let the text use as much horizontal space as needed.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_width() const;

  /** The x coordinate of the text.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_x() ;

/** The x coordinate of the text.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_x() const;

  /** The y coordinate of the text.
   *
   * @return A PropertyProxy that allows you to get or set the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy< double > property_y() ;

/** The y coordinate of the text.
   *
   * @return A PropertyProxy_ReadOnly that allows you to get the value of the property,
   * or receive notification when the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< double > property_y() const;


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};


}


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Goocanvas::TextModel
   */
  Glib::RefPtr<Goocanvas::TextModel> wrap(GooCanvasTextModel* object, bool take_copy = false);
}


#endif /* _GOOCANVASMM_TEXTMODEL_H */

